VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "orthocentre"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Nom As String

'si le point est dfini nouveau comme ortho d'un triangle (et non par ncessit),
'on crit le numro du triangle ici
Public Linker As Integer

'c'est ce qui est renvoy
Public H As New point

'si l'orthocentre n'existe pas (du aux triangles aplatis par ex)
'exist = false
Public exist As Boolean
Public tobedeleted As Boolean

'c'est ce qu'on donne
Public a As New point
Public b As New point
Public c As New point

Public Sub Calculer()
Dim lambda1 As Currency, lambda2 As Currency
Dim M As New point, N As New point

'on prend lambda tel que M(l) = (1-l)*A + l * B
'et CM perpendiculaire  AB
lambda1 = ((c.Y - a.Y) * (b.Y - a.Y) + (c.X - a.X) * (b.X - a.X)) / ((b.X - a.X) ^ 2 + (b.Y - a.Y) ^ 2)
M.X = (1 - lambda1) * a.X + lambda1 * b.X
M.Y = (1 - lambda1) * a.Y + lambda1 * b.Y

'on prend lambda tel que N(l) = (1-l)*B + l * C
'et AN perpendiculaire  BC
lambda2 = ((a.Y - b.Y) * (c.Y - b.Y) + (a.X - b.X) * (c.X - b.X)) / ((c.X - b.X) ^ 2 + (c.Y - b.Y) ^ 2)
N.X = (1 - lambda2) * b.X + lambda2 * c.X
N.Y = (1 - lambda2) * b.Y + lambda2 * c.Y

Set H = geom.Intersection(c, M, a, N)


End Sub

Public Sub Exister()
tobedeleted = False
exist = True
a.exist = True
b.exist = True
c.exist = True
H.exist = True
End Sub

Private Sub Class_Initialize()
tobedeleted = False
exist = True
Nom = "Orthocentre"
End Sub

Public Sub Destruction()

tobedeleted = True

If Not a.tobedeleted Then
a.Destruction
End If

If Not b.tobedeleted Then
b.Destruction
End If

If Not c.tobedeleted Then
c.Destruction
End If

End Sub

Public Sub Analyse()
exist = a.exist And b.exist And c.exist
If exist Then
Calculer
exist = H.exist
End If
End Sub

Public Sub Tracer(ecran As PictureBox)
H.Tracer ecran
End Sub
